% Show and compensate edge shifts of the MZ wavelet transform.
% Aleksandra Pizurica TELIN/UGent May 2004.


% create a test image
X=zeros (256,256);
X(:,100:256)=255;

[A1,Dx1,Dy1]=wt2_mz(X,0);   
[A2,Dx2,Dy2]=wt2_mz(A1,1);   
[A3,Dx3,Dy3]=wt2_mz(A2,2);  
[A4,Dx4,Dy4]=wt2_mz(A3,3); 

figure('units','normalized','position',[0.1 0.05 0.4 0.8]);
subplot(5,1,1),plot(X(100,:))
axis([80 110 0 300])
ylabel('Input signal');
title('Original');
subplot(5,1,2),plot(Dx1(100,:))
axis([80 110 0 600])
ylabel('scale 1');
subplot(5,1,3),plot(Dx2(100,:))
axis([80 110 0 600])
ylabel('scale 2');
subplot(5,1,4),plot(Dx3(100,:))
axis([80 110 0 600])
ylabel('scale 3');
subplot(5,1,5),plot(Dx4(100,:))
axis([80 110 0 600])
ylabel('scale 4');


% Shifts at different scales
s1=1;
s2=2;
s3=4;
s4=8;

% Unshifting detail images

[M,N]=size(X);

Dx1_unshift=UnshiftMZwavelet(Dx1,s1,1);
Dx2_unshift=UnshiftMZwavelet(Dx2,s2,1);
Dx3_unshift=UnshiftMZwavelet(Dx3,s3,1);
Dx4_unshift=UnshiftMZwavelet(Dx4,s4,1);

figure('units','normalized','position',[0.5 0.05 0.4 0.8]);
subplot(5,1,1),plot(X(100,:))
axis([80 110 0 300])
ylabel('Input signal');
title('Unshifted');
subplot(5,1,2),plot(Dx1_unshift(100,:),'r')
axis([80 110 0 600])
ylabel('scale 1');
subplot(5,1,3),plot(Dx2_unshift(100,:),'r')
axis([80 110 0 600])
ylabel('scale 2');
subplot(5,1,4),plot(Dx3_unshift(100,:),'r')
axis([80 110 0 600])
ylabel('scale 3');
subplot(5,1,5),plot(Dx4_unshift(100,:),'r')
axis([80 110 0 600])
ylabel('scale 4');


