%=======================================================================
%
% Demo program for the wavelet decomposition and reconstruction.
% of an image, using quadratic spline wavelets from Mallat&Zhong'92.
% Implementation with three detail images at each resolution scale.
%
% Author: Aleksandra Pizurica TELIN/RUG jan. 1998.
%========================================================================



%clear all;
%close all;

global InputType SCAN filename;

LogTransf=''; 
InputType=0;
 
while (InputType~=1 & InputType~=2 & InputType~=3 & InputType~=4)  
   InputType=input('\nInput image format:\n1. "*.tif"\n2. "*.sg2"\n3. "*.mat"\n4. "*.bin"\n>>  ');
end
imload;
X=SCAN;
[M,N]=size(X);


if(InputType==4)
    X=background_removal(X);
    X=normalize(X);
    while (LogTransf~='y' & LogTransf~='n')
       LogTransf=input('\nPerform logarithmic transform? (y/n)','s');
    end
    if (LogTransf=='y');
       X=log(X+1);
    end
end

%Decomposition
  
  [A1,HL1,LH1,HH1]=wt3det_spline(X,0);   
  [A2,HL2,LH2,HH2]=wt3det_spline(A1,1);   
  [A3,HL3,LH3,HH3]=wt3det_spline(A2,2); 
  [A4,HL4,LH4,HH4]=wt3det_spline(A3,3); 
  [A5,HL5,LH5,HH5]=wt3det_spline(A4,4); 
  
  
%Reconstruction
  
   A4r=iwt3det_spline(A5,HL5,LH5,HH5,4);
   A3r=iwt3det_spline(A4r,HL4,LH4,HH4,3);
   A2r=iwt3det_spline(A3r,HL3,LH3,HH3,2);
   A1r=iwt3det_spline(A2r,HL2,LH2,HH2,1);
   A0r=iwt3det_spline(A1r,HL1,LH1,HH1,0);
  
  figure
  subplot(2,1,1),imagesc(X);
  title('Original image');
  subplot(2,1,2),imagesc(A0r);
  title('Reconstructed image');
  colormap(gray);
  
  figure
  subplot(3,3,1),imagesc(HL1);
  axis off;
  title('HL1');
  subplot(3,3,2),imagesc(LH1);
  axis off;
  title('LH1');
  subplot(3,3,3),imagesc(HH1);
  axis off;
  title('HH1');
  subplot(3,3,4),imagesc(HL2);
  axis off;
  title('HL2');
  subplot(3,3,5),imagesc(LH2);
  axis off;
  title('LH2');
  subplot(3,3,6),imagesc(HH2);
  axis off;
  title('HH2');
  subplot(3,3,7),imagesc(HL3);
  axis off;
  title('HL3');
  subplot(3,3,8),imagesc(LH3);
  axis off;
  title('LH3');
  subplot(3,3,9),imagesc(HH3);
  axis off;
  title('HH3');
  colormap(gray);
    
  %figure
  %imagesc(X-A0r);
  %colormap(gray);
  


